Paint Pearls(HDU 5009)

来源:互联网 发布:github java 项目 编辑:程序博客网 时间:2024/06/07 23:45

Paint Pearls

Time Limit: 4000/2000 MS (Java/Others)    Memory Limit: 65536/65536 K (Java/Others)
Total Submission(s): 2221    Accepted Submission(s): 719


Problem Description
Lee has a string of n pearls. In the beginning, all the pearls have no color. He plans to color the pearls to make it more fascinating. He drew his ideal pattern of the string on a paper and asks for your help. 

In each operation, he selects some continuous pearls and all these pearls will be painted to their target colors. When he paints a string which has k different target colors, Lee will cost k2 points. 

Now, Lee wants to cost as few as possible to get his ideal string. You should tell him the minimal cost.
 

Input
There are multiple test cases. Please process till EOF.

For each test case, the first line contains an integer n(1 ≤ n ≤ 5×104), indicating the number of pearls. The second line contains a1,a2,...,an (1 ≤ ai ≤ 109) indicating the target color of each pearl.
 

Output
For each test case, output the minimal cost in a line.
 

Sample Input
31 3 3103 4 2 4 4 2 4 3 2 2
 

Sample Output
27
 

Source
2014 ACM/ICPC Asia Regional Xi'an Online
 

题意:
给你一个数列,每个数代表一种颜色,每次选一个区间覆盖,覆盖的费用是区间内颜色种类数的平方,直到覆盖整个数列,求最小花费。

分析:
利用dp,转移方程:dp[i] = min(dp[i], dp[j]+k*k);dp[i]表示在第i个数这里时的最小费用。由于时间复杂度为O(n*n),故会超时。所以需要各种剪枝。我已TLE n次了==。 这里重点就是如何快速查询 j+1~i 有几种不同元素。正解应该是利用什么链表吧,不过我不会,只好利用各种赖皮技术。我利用两个剪枝:1.当总的颜色种类很少并且n很大时,可直接输出种类的平方。2.因为总的颜色种类最多n,故最小花费最多也是50000。所以当计算到比k*k>n时就不用继续算了,直接就是n。

不想说那么多了,其实我只是想练一下 dp 的,谁知道有这么多麻烦,其实这题最后是各种乱搞过的。
非正解(乱搞)代码:
#include<stdio.h>#include<set>#include<algorithm>using namespace std;#define INF 1<<30const int N = 50010;int main(){    int n, i, j, a[N], k[N], dp[N];    while(~scanf("%d", &n))    {        set<int> m;        for(i=1; i<=n; i++)        {            scanf("%d", a+i);            m.insert(a[i]);        }        int x = m.size();        if(n > 25 && x < 5) //快速算出类似1 2 1 2 1 2..的这种        {            printf("%d\n", x*x);            continue;        }        for(i=1; i<=n; i++)        {            dp[i] = (i==1 ? 1 : INF);            m.clear();            m.insert(a[i]);            k[i] = m.size();            for(j=i-1; j>=0; j--)            {                m.insert(a[j]);                k[j] = m.size();                if(k[j+1] > 5) break; //原谅我这里耍赖皮==                dp[i] = min(dp[i], dp[j]+k[j+1]*k[j+1]);            }        }        printf("%d\n", dp[n]);    }    return 0;}


0 0